import greenfoot.*;

import java.io.*;
import javax.sound.sampled.*;

/**
 * Write a description of class FlightSound here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class FlightSound implements LineListener
{
    AudioFormat format = new AudioFormat(44000, 16, 1, true, true);
    byte[] soundWaveBytes;
    Clip clip;

    FlightSound(double timePerFrame, double vy, double g, double impactTime)
    { 
        short[] soundWave = new short[(int)(timePerFrame * 44000.0 * (impactTime - 5))];
       
        double a = 0;
        for (int i = 0; i < soundWave.length; i++)
        {
            // t is the frame number:
            double t = (double)i / (timePerFrame * 44000.0);

            // The 0.25 and /3200 are magic constants fiddled with to get a good sound.
            // The other part is the actual height of the projectile
            a += 0.25 + (t * vy - 0.5 * g * t * (t - 1)) / 3200.0;
            
            // The sound wave can go from -32768 to 32767, so multiplying sin
            // (which ranges from -1 to +1 by 8000 means it will be about
            // a quarter of max volume:
            soundWave[i] = (short)(8000 * Math.sin(a));
            
        }
        
        soundWaveBytes = new byte[soundWave.length * 2];
        for (int i = 0; i < soundWave.length; i++)
        {
            soundWaveBytes[i*2] = (byte)(soundWave[i] >>> 8);
            soundWaveBytes[(i*2) + 1] = (byte)(soundWave[i] & 255);
        }
        
    }
    
    public void play()
    {
        ByteArrayInputStream baiStream = new ByteArrayInputStream(soundWaveBytes);
        AudioInputStream aiStream = new AudioInputStream(baiStream,format,soundWaveBytes.length / 2);
        
        Line.Info linfo = new Line.Info(Clip.class);
        try
        {
            Line line = AudioSystem.getLine(linfo);
            clip = (Clip) line;
            clip.addLineListener(this);
            clip.open(aiStream);
            clip.start();
        }
        catch (LineUnavailableException e)
        {
        }
        catch (IOException e)
        {
        }
    }
    
    public void update(LineEvent le)
    {
        LineEvent.Type t = le.getType();
        if (t == LineEvent.Type.STOP)
        {
            clip.close();
            soundWaveBytes = null;
        }
    }
}
