import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Tank here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public abstract class Player extends Actor
{
    public static double getVelX(double angleRadians, double forceFactor)
    {
        return Math.cos(angleRadians) * (ProjectileWorld.MIN_FORCE + forceFactor * (ProjectileWorld.MAX_FORCE - ProjectileWorld.MIN_FORCE));
    }
    
    public static double getVelY(double angleRadians, double forceFactor)
    {
        return -Math.sin(angleRadians) * (ProjectileWorld.MIN_FORCE + forceFactor * (ProjectileWorld.MAX_FORCE - ProjectileWorld.MIN_FORCE));
    }
    
    
    public abstract void startTurn();
    
    public void fire(double angleRadians, double forceFactor)
    {
        final int minDegrees = -180 + ProjectileWorld.LOWEST_ANGLE;
        final int maxDegrees = -ProjectileWorld.LOWEST_ANGLE;
        if (angleRadians < Math.toRadians(minDegrees)|| angleRadians > Math.toRadians(maxDegrees))
        {
            throw new IllegalArgumentException("Angle (" + Math.toDegrees(angleRadians) + ") outside acceptable range: " + minDegrees + " to " + maxDegrees);
        }
        if (forceFactor < 0 || forceFactor > 1)
        {
            throw new IllegalArgumentException("Force factor out of range");
        }
        
        double vx = getVelX(angleRadians, forceFactor);
        double vy = getVelY(angleRadians, forceFactor);
        
        getWorld().addObject(new Projectile(this, vx, vy), getX(), getY());
        
        FlightSound sound = new FlightSound(((ProjectileWorld)getWorld()).getTimePerFrame(),vy, ProjectileWorld.GRAVITY, Projectile.getImpactTime(angleRadians, forceFactor));
        sound.play();
    }
    
    public void landed(double x, double y)
    {
    }
}
