import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class ProjectileWorld here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class ProjectileWorld extends World
{
    private long startMillis = 0;
    private int numFrames = 0;
    private final int groundHeight;
    
    public static final double MAX_FORCE = 8.5;
    public static final double MIN_FORCE = 3.5;
    public static final double GRAVITY = 0.1;
    public static final int LOWEST_ANGLE = 30;
    
    private Player[] players;
    private int curPlayer;
    private int turnCountdown;

    /**
     * Constructor for objects of class ProjectileWorld.
     * 
     */
    public ProjectileWorld(Player opponent)
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(800, 600, 1, false); 
        
        groundHeight = 550;
        getBackground().setColor(new java.awt.Color(0.8f, 0.95f, 1.0f, 1.0f));
        getBackground().fill();
        getBackground().setColor(new java.awt.Color(0.4f, 0.7f, 0.4f, 1.0f));
        getBackground().fillRect(0, groundHeight, getWidth(), getHeight());
        
        players = new Player[] {new HumanPlayer(), opponent};
        addObject(players[0], Greenfoot.getRandomNumber(getWidth()/2 - 100) + 50, groundHeight);
        addObject(players[1], Greenfoot.getRandomNumber(getWidth()/2 - 100) + getWidth()/2 + 50, groundHeight);
        
        curPlayer = 0;
        turnCountdown = 10;
        started();
    }
    
    public void started()
    {
        numFrames = 0;
        startMillis = System.currentTimeMillis();
    }
    
    private double t;
    
    public void act()
    {
        numFrames += 1;
        t = getTimePerFrame();
        
        if (turnCountdown > 0)
        {
            turnCountdown -= 1;
            if (turnCountdown == 0)
            {
                players[curPlayer].startTurn();
            }
        }
    }
    
    public double getTimePerFrame()
    {
        return (double)(System.currentTimeMillis() - startMillis) / (1000.0 * (double)(numFrames));
    }
    
    public boolean hitsGround(double startX, double startY, double endX, double endY)
    {
        return endY > groundHeight;
    }
    
    public void landed()
    {
        curPlayer = (curPlayer + 1) % players.length;
        turnCountdown = 30;
    }
    
    public void hitPlayer(Player player)
    {
        if (player == players[curPlayer])
        {
            //Hit self -- no worries:
            landed();
        }
        else
        {
            //Hit an opponent -- game over:
            GreenfootImage gameOverImg = new GreenfootImage("Game Over\nPlayer " + (curPlayer + 1) + " Wins!", 100, new java.awt.Color(0.5f, 0.1f, 0.1f, 1.0f), null);
            getBackground().drawImage(gameOverImg, (getWidth() - gameOverImg.getWidth()) / 2, 100);
        }
    }
}
